import java.util.Arrays;
import java.util.HashMap;
import java.util.Random;

class CollectAllPermutations{

    public static int[] rand_perm(int[] arr, int n, boolean mode){
        // create instance of Random class
        Random rand = new Random();
        int rand_int = 0;
        for(int i = 0; i < arr.length; i++){
            // Generate random integers in range i to n
             rand_int = rand.nextInt(n - i) + i;
             int temp;
             // swap current number with a random number in the array
             temp = arr[i];
             arr[i] = arr[rand_int];
             arr[rand_int] = temp;
        }
        if(mode){
            System.out.println(Arrays.toString(arr));
        }
        return arr;
    }

    static int factorial(int n){    
        // calculates the factorial of n to determine stop condition when all possible permutations are found
        if (n == 0)    
          return 1;    
        else    
          return(n * factorial(n-1));    
       }    

    public static void main(String[] args) {
        // args is an array of Strings
        boolean mode = false;
        int n = 0;
         // System.out.println(Arrays.toString(args));
        // check if arguements are valid
        if(args.length != 2){
            System.out.print("invalid arguements! please pass n and mode");
            System.exit(0);
        }
        else{
            n = Integer.parseInt(args[0]);
            mode = args[1].toLowerCase().equals("verbose");
        }

        int[] arr = new int[n];
        for(int i=1; i <= n; i++){
            arr[i-1] = i;
        }

        int[] perm_arr = new int[n]; // get new permutation
        HashMap<String, Integer> tracker = new HashMap<>(); //  to keep track of unique permutations so far
        int fact = factorial(n); // callculate end condition
        int iterations = 0;

        while(tracker.size() < fact){
            iterations ++;
            perm_arr = rand_perm(arr, n, mode);
            //System.out.println(String.valueOf(tracker.size()));
            String key = Arrays.toString(perm_arr);

            if(tracker.containsKey(Arrays.toString(perm_arr))){
                tracker.put(key, tracker.get(key) + 1);
            }
            else{
                tracker.put(Arrays.toString(perm_arr),1);
            }
        }
        System.out.printf("All permutations of %d collected in %d iterations\n",n,iterations);
    }
}
