import java.util.Arrays;
import java.util.HashMap;
import java.util.Random;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;


class Experiments{

    public static int[] rand_perm(int[] arr, int n, boolean mode, int seed){
        // create instance of Random class
        Random rand = new Random(seed);
        int rand_int = 0;
        for(int i = 0; i < arr.length; i++){
            // Generate random integers in range i to n
             rand_int = rand.nextInt(n - i) + i;
             int temp;
             temp = arr[i];
             arr[i] = arr[rand_int];
             arr[rand_int] = temp;
        }
        if(mode){
            System.out.println(Arrays.toString(arr));
        }
        return arr;
    }

    static int factorial(int n){    
        // calculates the factorial of n to determine stop condition when all possible permutations are found
        if (n == 0)    
          return 1;    
        else    
          return(n * factorial(n-1));    
       }    

    public static String generate_experiment(int n, boolean mode){
        int[] arr = new int[n];
            for(int i=1; i <= n; i++){
                arr[i-1] = i;
            }

            int[] perm_arr = new int[n]; // get new permutation
            HashMap<String, Integer> tracker = new HashMap<>(); //  to keep track of unique permutations so far
            int fact = factorial(n); // callculate end condition
            int iterations = 0;

            while(tracker.size() < fact){
                iterations ++;
                Random rand = new Random();
                int seed = rand.nextInt();
                perm_arr = rand_perm(arr, n, mode, seed);
                String key = Arrays.toString(perm_arr);

                if(tracker.containsKey(Arrays.toString(perm_arr))){
                    tracker.put(key, tracker.get(key) + 1);
                }
                else{
                    tracker.put(Arrays.toString(perm_arr),1);
                }
            }
            String result = "All permutations of "+String.valueOf(n)+" collected in "+String.valueOf(iterations)+" iterations\n";
            System.out.print(result);
            return result;
    }
    public static void main(String[] args) throws IOException{
        // args is an array of Strings
        boolean mode = false;
        StringBuilder str = new StringBuilder();
        for(int exp = 0; exp <10; exp++){
            Path fileName = Path.of("experiments_"+exp+".txt");
            for(int n = 2; n < 11; n++){
                String result = generate_experiment(n, mode);
                str.append(result);
            }
            Files.writeString(fileName, str.toString());
        }
    }
}
